#include <bits/stdc++.h>

using namespace std;
const int N=1e5+3;
const int MAXL=1000000000+7;
long long podniz(long long a[],long long n)
{
    long long i,j,k,suma=0;
    for(i=1;i<=n;i++)
    {
        for(j=0;j<=n-i;j++)
        {
            long long z=j+i-1;
            for(k=j;k<=z;k++)
                suma+=a[k];
        }
    }
    return suma;
}
int main()
{
    long long n,a[N],i,k,suma=0;
    cin>>n>>k;
    for(i=0;i<n;i++) cin>>a[i];
    if(k==1)
    {
        cout<<podniz(a,n)<<endl;
    }
    else if(k==0)
    {
        for(i=0;i<n;i++) suma+=a[i];
        cout<<suma%MAXL<<endl;
    }
    return 0;
}